(define rules '((primitiverule (condition ((formula A (not PHI))(formula A PHI))) 
  
 (add ((formula A bottom))))


(primitiverule (condition ((formula A bottom))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A (not top)))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A (PHI1 and PHI2)))) 
  
 (add ((formula A PHI1) (formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 imply PHI2))(formula A PHI1))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 imply PHI2)))) 
(suchthat (and (not (node-contains? set A PHI1))  (not (node-contains? set A PHI2)))) 
 (add ((formula A ((not PHI1) or PHI2)))))


(primitiverule (condition ((formula A (not (PHI1 imply PHI2))))) 
  
 (add ((formula A (PHI1 and (not PHI2))))))


(primitiverule (condition ((formula A (PHI1 equiv PHI2)))) 
  
 (add ((formula A ((PHI1 imply PHI2) and (PHI2 imply PHI1))))))


(primitiverule (condition ((formula A (not (PHI1 and PHI2))))) 
  
 (add ((formula A ((not PHI1) or (not PHI2))))))


(primitiverule (condition ((formula A (not (PHI1 equiv PHI2))))) 
  
 (add ((formula A (((not PHI1) and PHI2) or (PHI1 and (not PHI2)))))))


(primitiverule (condition ((formula A (not (PHI1 or PHI2))))) 
  
 (add ((formula A (not PHI1)) (formula A (not PHI2)))))


(primitiverule (condition ((formula A (not (not PHI1))))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI2)))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A ((not PHI1) or PHI2))(formula A (PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (not (diamond PHI))))) 
  
 (add ((formula A (box (not PHI))))))


(primitiverule (condition ((formula A (not (box PHI))))) 
  
 (add ((formula A (diamond (not PHI))))))


(primitiverule (condition ((formula A (PHI1 or (not PHI2)))(formula A PHI2))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (PHI1 or PHI2)))) 
  
 (add-nondeterminist ((formula A PHI1))((formula A PHI2))))


(primitiverule (condition ((formula A (box R PHI))(A link R B)(world B))) 
  
 (add ((formula B PHI))))


(primitiverule (condition ((formula A (boxinv R PHI))(B link R A)(world B))) 
  
 (add ((formula B PHI))))


(primitiverule (condition ((world A)(world B))) 
(suchthat (and (not (equal? A B)) (worldsformulasincluded? set B A)))(merge A B) 
 (add ((formula A merged))))


(primitiverule (condition ((formula A (diamond R PHI)))) 
(suchthat (not (node-contains? set A 'merged))) 
 (add ((formula B PHI) (A link R B) (world B))))


(primitiverule (condition ((formula A (diamondinv R PHI)))) 
(suchthat (not (node-contains? set A 'merged))) 
 (add ((formula B PHI) (B link R A) (world B))))


(primitiverule (condition ((formula A (u PHI))(world B))) 
  
 (add ((formula B PHI))))


))







(define examples '((

(formula n (u (Mamifere imply Animal)))
(formula n (u (Animal imply (box vision Eye))))

(formula n (diamondinv vision Mamifere))
(formula n Camera)
(formula n (diamondinv Mamifere))
(formula n (u (Camera imply (not Eye))))


)))


