(define rules '((primitiverule (condition ((formula A ok)(formula A world)(formula B (p PHI)))) 
(suchthat (and (equal? (list-element-last A) B) (> (list-size A) 1))) 
 (add ((world (unquote (list-greatest-strict-prefix (quote A)))) (formula (unquote (list-greatest-strict-prefix (quote A))) PHI) (formula (unquote (list-greatest-strict-prefix (quote A))) ok))))


(primitiverule (condition ((formula A (PHI1 and PHI2)))) 
  
 (add ((formula A PHI1) (formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 imply PHI2)))) 
  
 (add ((formula A ((not PHI1) or PHI2)))))


(primitiverule (condition ((formula A (not (PHI1 imply PHI2))))) 
  
 (add ((formula A (PHI1 and (not PHI2))))))


(primitiverule (condition ((formula A (PHI1 equiv PHI2)))) 
  
 (add ((formula A ((PHI1 imply PHI2) and (PHI2 imply PHI1))))))


(primitiverule (condition ((formula A (not (PHI1 and PHI2))))) 
  
 (add ((formula A ((not PHI1) or (not PHI2))))))


(primitiverule (condition ((formula A (not (PHI1 equiv PHI2))))) 
  
 (add ((formula A (((not PHI1) and PHI2) or (PHI1 and (not PHI2)))))))


(primitiverule (condition ((formula A (not (PHI1 or PHI2))))) 
  
 (add ((formula A ((not PHI1) and (not PHI2))))))


(primitiverule (condition ((formula A (not (not PHI1))))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (not PHI))(formula A PHI))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A bottom))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A (not top)))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula B (p PHI))(formula B (p PSI)))) 
 (suchthat (diff? PSI PHI))
 (add ((halt)) ) )


(primitiverule (condition ((formula A (AGT thinks PHI)))) 
(suchthat (literal? A)) 
 (add ((formula B PHI) (A link AGT B) (world B))))


(primitiverule (condition ((formula W L)(formula W world))) 
(suchthat (and (literal? L) (diff? L 'ok) (diff? L '(not ok)))) 
 (add ((world ((unquote (car (quote W))))) (formula ((unquote (car (quote W)))) L))))


(primitiverule (condition ((formula A world)(A link AGT B)(world B))) 
(suchthat (> (list-size A) 1)) 
 (add ((formula (unquote (list-greatest-strict-prefix (quote A))) world) (formula (unquote (list-greatest-strict-prefix (quote B))) world) ((unquote (list-element-last (quote A))) link AGT (unquote (list-element-last (quote B)))) ((unquote (list-greatest-strict-prefix (quote A))) link AGT (unquote (list-greatest-strict-prefix (quote B)))) (world (unquote (list-greatest-strict-prefix (quote A)))) (world (unquote (list-greatest-strict-prefix (quote B)))) (world (unquote (list-element-last (quote A)))) (world (unquote (list-element-last (quote B)))))))


(primitiverule (condition ((A link  B)(A link AGT B)(C link  D)(C link AGT D)(world A)(world B)(world C)(world D)(world P))) 
(suchthat (equal? P (list-cons-end A C)))(let ((E (list-cons-end B D))))
 
 (add ((world E) (P link AGT E) (P link E))))


(primitiverule (condition ((formula A (AGT thinks PHI))(formula A world))) 
 (let ((B (list-new-different-symbols (list-size 'A)))))
 
 (add ((world B) (A link AGT B) (formula B PHI) (formula B world))))


(primitiverule (condition ((formula A (AGT knows PHI))(A link AGT B)(world B))) 
  
 (add ((formula B PHI))))


(primitiverule (condition ((formula A (not (AGT knows PHI))))) 
  
 (add ((formula A (AGT thinks (not PHI))))))


(primitiverule (condition ((formula A (not (AGT thinks PHI))))) 
  
 (add ((formula A (AGT knows (not PHI))))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI2)))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A PHI)(formula A (PHI imply PSI)))) 
  
 (add ((formula A PSI))))


(primitiverule (condition ((formula A ((not PHI1) or PHI2))(formula A (PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or (not PHI2)))(formula A PHI2))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula (A B) (not ok))(formula B (p PHI)))) 
  
 (add ((formula A (not PHI)) (world A))))


(primitiverule (condition ((formula A (PHI1 or PHI2)))) 
  
 (add-nondeterminist ((formula A PHI1))((formula A PHI2))))


(primitiverule (condition ((formula A world))) 
  
 (add-nondeterminist ((formula A ok))((formula A (not ok)))))


(primitiverule (condition ((formula (A) (not ok)))) 
  
 (add ((halt)) ) )


))

