(define rules '((primitiverule (condition ( (formula A (lf L (PHI1 and PHI2)))(world A))) 
  
 (add ((formula A (lf L PHI1)) (formula A (lf L PHI2)))))


(primitiverule (condition ( (formula A (lf L (PHI1 imply PHI2)))(world A))) 
  
 (add ((formula A (lf L ((not PHI1) or PHI2))))))


(primitiverule (condition ( (formula A (lf L (not (PHI1 imply PHI2))))(world A))) 
  
 (add ((formula A (lf L (PHI1 and (not PHI2)))))))


(primitiverule (condition ( (formula A (lf L (PHI1 equiv PHI2)))(world A))) 
  
 (add ()))


(primitiverule (condition ( (formula A (lf L (not (PHI1 and PHI2))))(world A))) 
  
 (add ((formula A (lf L ((not PHI1) or (not PHI2)))))))


(primitiverule (condition ( (formula A (lf L (not (PHI1 equiv PHI2))))(world A))) 
  
 (add ((formula A (lf L ((not (PHI1 imply PHI2)) or (not (PHI2 imply PHI1))))))))


(primitiverule (condition ( (formula A (lf L (not (PHI1 or PHI2))))(world A))) 
  
 (add ((formula A (lf L (not (PHI1٧ PHI2)))) (formula A (lf L ((not PHI1) and (not PHI2)))))))


(primitiverule (condition ( (formula A (lf L (not (not PHI1))))(world A))) 
  
 (add ((formula A (lf L PHI1)))))


(primitiverule (condition ( (formula A (lf L bottom))(world A))) 
  
 (add ((halt)) ) )


(primitiverule (condition ( (formula A (lf L (not PHI)))(formula A (lf L PHI))(world A))) 
  
 (add ((halt)) ) )


(primitiverule (condition ( (formula B (lf L (box AGT PHI)))(world B)(world A))) 
  
 (add ((A link AGT A))))


(primitiverule (condition ( (formula B (lf L (diamond AGT PHI)))(world B)(world A))) 
  
 (add ((A link AGT A))))


(primitiverule (condition ( (formula A (lf L (not (diamond AGT PHI))))(world A))) 
  
 (add ((formula A (lf L (box AGT (not PHI)))))))


(primitiverule (condition ( (formula A (lf L (not (box AGT PHI))))(world A))) 
  
 (add ((formula A (lf L (diamond AGT (not PHI)))))))


(primitiverule (condition ( (formula A (lf L (box AGT PHI)))(A link AGT B)(world A)(world B))) 
  
 (add ((formula B (lfbox L PHI)))))


(primitiverule (condition ( (A link AGT B)(world A)(world B))) 
  
 (add ((B link AGT A))))


(primitiverule (condition ( (A link AGT B)(B link AGT C)(world A)(world B)(world C))) 
  
 (add ((A link AGT C))))


(primitiverule (condition ( (formula A (lfbox () PHI))(world A))) 
  
 (add ((formula A (lf () PHI)))))


(primitiverule (condition ( (formula A (lfbox L PHI))(world A))) 
 (suchthat (not (set-empty? L)))
 (add-nondeterminist ((formula A (lf L PHI)))((formula A (lfbox (unquote (cdr (quote L))) (not (unquote (car (quote L)))))))))


(primitiverule (condition ( (formula A (lf L PHI))(world A))) 
(suchthat (not (set-empty? L))) 
 (add ((formula A (lf (unquote (cdr (quote L))) (unquote (car (quote L))))))))


(primitiverule (condition ( (formula A (lf L (anndiamond PSI PHI)))(world A))) 
  
 (add ((formula A (lf (unquote (cons (quote PSI) (quote L))) PHI)))))


(primitiverule (condition ( (formula A (lf L (annbox PSI PHI)))(world A))) 
  
 (add-nondeterminist ((formula A (lf L (not PSI))))((formula A (lf (unquote (cons (quote PSI) (quote L))) PHI)))))


(primitiverule (condition ( (formula A (lf L (not (annbox PSI PHI))))(world A))) 
  
 (add ((formula A (lf L (anndiamond PSI (not PHI)))))))


(primitiverule (condition ( (formula A (lf L (not (anndiamond PSI PHI))))(world A))) 
  
 (add ((formula A (lf L (not (annbox PSI (not PHI))))))))


(primitiverule (condition ( (formula A (lf L P))(world A))) 
(suchthat (proposition? P)) 
 (add ((formula A (lf () P)))))


(primitiverule (condition ( (formula A (lf L (not P)))(world A))) 
(suchthat (proposition? P)) 
 (add ((formula A (lf () (not P))))))


(primitiverule (condition ( (world A))) 
(suchthat (not (equal? A 'extra))) 
 (add ((A link 1 A))))


(primitiverule (condition ( (world A))) 
(suchthat (not (equal? A 'extra))) 
 (add ((A link 2 A))))


(primitiverule (condition ( (formula A (lf L (p PHI)))(formula extra (pi B S1 S2))(formula extra (S1 vdash L))(formula extra (S1 hsadv L))(formula extra (S2 vdash M))(world A)(world extra))) 
(suchthat (and (equal? (car M) PHI) (equal? (cdr M) L))) 
 (add ((formula extra (pi A S1 S2)))))


(primitiverule (condition ( (formula A (lf L (p PHI)))(formula extra (pi M S1 S2))(formula extra (S1 vdash L))(formula extra (S1 hsadv L))(world A)(world extra))) 
  
 (add ((formula extra (pi A S1 S3)) (formula extra (S3 vdash (unquote (cons (quote PHI) (quote L))))) (formula extra (setofworlds S3)))))


(primitiverule (condition ( (formula A (lf L (p PHI)))(world A))) 
  
 (add ((formula extra (pi A S1 S2)) (formula extra (S1 vdash L)) (formula extra (S1 hsadv L)) (formula extra (S2 vdash (unquote (cons (quote PHI) (quote L))))) (formula extra (setofworlds S1)) (formula extra (setofworlds S2)) (world extra))))


(primitiverule (condition ( (formula extra (pi N S1 S2))(world extra))) 
  
 (add ((formula extra (N in S2)))))


(primitiverule (condition ( (formula A (lf L (not (p PHI))))(formula extra (pi A S1 S2))(world A)(world extra))) 
  
 (add ((formula extra (((S1 notvdash L) or (S1 nothsadv L)) or (S2 notvdash (unquote (cons (quote PHI) (quote L)))))))))


(primitiverule (condition ( (formula extra (S vdash L))(formula extra (A in S))(world extra))) 
  
 (add ((world A) (formula A (lf L top)))))


(primitiverule (condition ( (formula extra (A notin S))(formula extra (S hsadv L))(world extra))) 
  
 (add ((world A) (formula A (nlf L top)))))


(primitiverule (condition ( (formula extra (S notvdash L))(world extra))) 
  
 (add ((formula extra (A in S)) (formula A (nlf L top)) (world A))))


(primitiverule (condition ( (formula extra (S nothsadv L))(world extra))) 
  
 (add ((formula extra (A notin S)) (formula A (lf L top)) (world A))))


(primitiverule (condition ( (formula A (nlf L PHI))(world A))) 
 (suchthat (not (set-empty? L)))
 (add-nondeterminist ((formula A (lf L (not PHI))))((formula A (nlf (unquote (cdr (quote L))) (unquote (car (quote L))))))))


(primitiverule (condition ( (formula extra (N in S))(world extra))) 
  
 (add ((formula N (in S)) (world N))))


(primitiverule (condition ( (formula extra (pi A B C))(world A)(world extra))) 
  
 (add ((formula A (pi A B C)))))


(primitiverule (condition ( (world A)(world B))) 
(suchthat (and (not (equal? A B)) (sameformulas? set A B)))(merge A B) 
 (add ((formula A donotrewritediamond))))


(primitiverule (condition ( (formula A (lf L (diamond AGT PHI)))(world A))) 
(suchthat (not (node-contains? set A 'donotrewritediamond))) 
 (add ((formula B (lf L PHI)) (A link AGT B) (world B))))


(primitiverule (condition ( (formula A (nlf () PHI))(world A))) 
  
 (add ((formula A (lf () (not PHI))))))


(primitiverule (condition ( (formula A (lf L (not top)))(world A))) 
  
 (add ((formula A (lf L bottom)))))


(primitiverule (condition ( (formula A (lf L (not bottom)))(world A))) 
  
 (add ((formula A (lf L top)))))


(primitiverule (condition ( (formula A (lf L (PHI1 or PHI2)))(world A))) 
  
 (add-nondeterminist ((formula A (lf L PHI1)))((formula A (lf L PHI2)))))


(primitiverule (condition ( (formula extra (D or E))(world extra))) 
  
 (add-nondeterminist ((formula extra D))((formula extra E))))


(primitiverule (condition ( (formula extra (setofworlds S))(world extra)(world A))) 
 (suchthat (and (not (equal? A 'extra)) (not (equal? A 'pi))))
 (add-nondeterminist ((formula extra (A notin S)))((formula extra (A in S)))))


(primitiverule (condition ( (formula extra (pi A B C))(world extra))) 
  
 (add ((formula pi (pi A B C)) (world pi))))


))

