(define rules '((primitiverule (condition ( (formula A (not PHI))(formula A PHI)(world A))) 
  
 (add ((formula A bottom))))


(primitiverule (condition ( (formula A bottom)(world A))) 
  
 (add ((halt)) ) )


(primitiverule (condition ( (formula A (PHI1 and PHI2))(world A))) 
  
 (add ((formula A PHI1) (formula A PHI2))))


(primitiverule (condition ( (formula A (PHI1 imply PHI2))(world A))) 
  
 (add ((formula A ((not PHI1) or PHI2)))))


(primitiverule (condition ( (formula A (not (PHI1 imply PHI2)))(world A))) 
  
 (add ((formula A (PHI1 and (not PHI2))))))


(primitiverule (condition ( (formula A (PHI1 equiv PHI2))(world A))) 
  
 (add ((formula A ((PHI1 imply PHI2) and (PHI2 imply PHI1))))))


(primitiverule (condition ( (formula A (not (PHI1 and PHI2)))(world A))) 
  
 (add ((formula A ((not PHI1) or (not PHI2))))))


(primitiverule (condition ( (formula A (not (PHI1 equiv PHI2)))(world A))) 
  
 (add ((formula A (((not PHI1) and PHI2) or (PHI1 and (not PHI2)))))))


(primitiverule (condition ( (formula A (not (PHI1 or PHI2)))(world A))) 
  
 (add ((formula A ((not PHI1) and (not PHI2))))))


(primitiverule (condition ( (formula A (not (not PHI1)))(world A))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ( (world A))) 
  
 (add ((A link A))))


(primitiverule (condition ( (A link  B)(B link  C)(world A)(world B)(world C))) 
  
 (add ((A link C))))


(primitiverule (condition ( (formula A (PHI1 or PHI2))(formula A (not PHI1))(world A))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ( (formula A (PHI1 or PHI2))(formula A (not PHI2))(world A))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ( (formula A ((not PHI1) or PHI2))(formula A (PHI1))(world A))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ( (formula A (not (diamond PHI)))(world A))) 
  
 (add ((formula A (box (not PHI))))))


(primitiverule (condition ( (formula A (not (box PHI)))(world A))) 
  
 (add ((formula A (diamond (not PHI))))))


(primitiverule (condition ( (formula A (PHI1 or (not PHI2)))(formula A PHI2)(world A))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ( (formula A (PHI1 or PHI2))(world A))) 
  
 (add-nondeterminist ((formula A PHI1))((formula A PHI2))))


(primitiverule (condition ( (formula A (box PHI))(A link  B)(world A)(world B))) 
  
 (add ((formula B PHI))))


(primitiverule (condition ( (A link  B)(world A)(world B))) 
(suchthat (and (not (equal? A B)) (worldsformulasincluded? set B A)))(merge A B) 
 (add ((formula A donotrewritediamond))))


(primitiverule (condition ( (formula A (diamond PHI))(world A))) 
(suchthat (not (node-contains? set A 'donotrewritediamond))) 
 (add ((formula B PHI) (A link B) (world B))))


))

