(define rules '((primitiverule (condition ((world (pre prop 2)))) 
  
 (add ((world (pre prop 2 neg)) (formula (pre prop 2 neg) (prepropneg (unquote (formula-disjonction-make (node-formulas-get set (quote (pre prop 2))))))))))


(primitiverule (condition ((formula A (PHI1 and PHI2)))) 
  
 (add ((formula A PHI1) (formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 imply PHI2)))) 
  
 (add ((formula A ((not PHI1) or PHI2)))))


(primitiverule (condition ((formula A (not (PHI1 imply PHI2))))) 
  
 (add ((formula A (PHI1 and (not PHI2))))))


(primitiverule (condition ((formula A (PHI1 equiv PHI2)))) 
  
 (add ((formula A ((PHI1 imply PHI2) and (PHI2 imply PHI1))))))


(primitiverule (condition ((formula A (not (PHI1 and PHI2))))) 
  
 (add ((formula A ((not PHI1) or (not PHI2))))))


(primitiverule (condition ((formula A (not (PHI1 equiv PHI2))))) 
  
 (add ((formula A (((not PHI1) and PHI2) or (PHI1 and (not PHI2)))))))


(primitiverule (condition ((formula A (not (PHI1 or PHI2))))) 
  
 (add ((formula A ((not PHI1) and (not PHI2))))))


(primitiverule (condition ((formula A (not (not PHI1))))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (not PHI))(formula A PHI))) 
  
 (add ((formula A bottom))))


(primitiverule (condition ((formula A bottom))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A (diamond PHI))(formula A (model 2)))) 
  
 (add ((world B) (A link B) (formula B PHI))))


(primitiverule (condition ((formula (A B) L))) 
(suchthat (literal? L)) 
 (add ((formula A L) (world A))))


(primitiverule (condition ((formula A (diamond PHI))(formula A (prof N))(formula A (model 1)))) 
(suchthat (and (proposition? A) (> N 0))) 
 (add ((formula B PHI) (formula B (prof (unquote (- N 1)))) (A link B) (world B))))


(primitiverule (condition ((formula A (prof N))(formula A (model 1))(A link  B)(world B))) 
  
 (add ((formula B (prof (unquote (- N 1)))))))


(primitiverule (condition ((formula (A B) (diamond PHI)))) 
  
 (add ((formula (C D) PHI) (formula (C D) ok) (A link C) ((A B) link (C D)) (B link D) (world (C D)) (world A) (world C) (world B) (world D))))


(primitiverule (condition ((formula C (model 1))(formula D (model 2))(C link  A)(D link  B)(world A)(world B)(world (C D)))) 
  
 (add-nondeterminist ((world (A B)) ((C D) link (A B)) (formula (A B) ok) (formula B (model 2)) (formula A (model 1)))((world (A B)) (formula (A B) (not ok)) (formula B (model 2)) (formula A (model 1)))))


(primitiverule (condition ((formula A (box PHI))(A link  B)(world B))) 
  
 (add ((formula B PHI))))


(primitiverule (condition ((formula A (not (box PHI))))) 
  
 (add ((formula A (diamond (not PHI))))))


(primitiverule (condition ((formula A (not (diamond PHI))))) 
  
 (add ((formula A (box (not PHI))))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI2)))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A ((not PHI1) or PHI2))(formula A (PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or (not PHI2)))(formula A PHI2))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (model I))(A link  B)(world B))) 
  
 (add ((formula B (model I)))))


(primitiverule (condition ((formula A (prof N))(formula B P)(formula (A B) ok)(formula (pre prop 2) (pre P PRE)))) 
  
 (add ((formula A PRE))))


(primitiverule (condition ((formula A (PHI1 or PHI2)))) 
  
 (add-nondeterminist ((formula A PHI1))((formula A PHI2))))


(primitiverule (condition ((formula (A B) (not ok))(formula (pre prop 2 neg) (prepropneg I)))) 
  
 (add ((formula (A B) I))))


(primitiverule (condition ((formula (A B) (not ok))(formula (A B) (pre P PRE)))) 
  
 (add ((world B) (world A) (formula B P) (formula A (not PRE)))))


))

