(define rules '((primitiverule (condition ((formula A (PHI1 and PHI2))(world A))) 
  
 (add ((formula A PHI1) (formula A PHI2))))


(primitiverule (condition ((formula A (not (PHI1 imply PHI2)))(world A))) 
  
 (add ((formula A PHI1) (formula A (not PHI2)))))


(primitiverule (condition ((formula A (PHI1 equiv PHI2))(world A))) 
  
 (add ((formula A (PHI1 imply PHI2)) (formula A (PHI2 imply PHI1)))))


(primitiverule (condition ((formula A (not (PHI1 equiv PHI2)))(world A))) 
  
 (add ((formula A (((not PHI1) and PHI2) or (PHI1 and (not PHI2)))))))


(primitiverule (condition ((formula A (not (not PHI1)))(world A))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (not PHI))(formula A PHI)(world A))) 
  
 (add ((formula A bottom))))


(primitiverule (condition ((formula A bottom)(world A))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A (diamond PHI))(world A))) 

 (add ((formula B PHI) (A link B) (world B))))


(primitiverule (condition ((formula A (box PHI))(A link  B)(world A)(world B))) 
  
 (add ((formula B PHI))))


(primitiverule (condition ((formula A (not (box PHI)))(world A))) 
  
 (add ((formula A (diamond (not PHI))))))


(primitiverule (condition ((formula A (not (diamond PHI)))(world A))) 
  
 (add ((formula A (box (not PHI))))))


(primitiverule (condition ((formula A (not (PHI1 or PHI2)))(world A))) 
  
 (add ((formula A (not PHI1)) (formula A (not PHI2)))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(world A))) 
  
 (add-nondeterminist ((formula A PHI1))((formula A PHI2))))


(primitiverule (condition ((formula A (PHI imply PSI))(world A))) 
  
 (add-nondeterminist ((formula A PSI))((formula A (not PHI)))))


(primitiverule (condition ((formula A (not (PHI1 and PHI2)))(world A))) 
  
 (add-nondeterminist ((formula A (not PHI1)))((formula A (not PHI2)))))


))





(define examples '(((formula n1 (((box ((diamond p) and (diamond (not p)))) and (diamond q)) and (diamond (not q)))))

((formula n1 (((box bottom) and (diamond p)) or (diamond q))))
((formula n1 ((diamond q) or ((box bottom) and (diamond p)))))
))


