(define rules '((primitiverule (condition ((formula A (PHI1 and PHI2)))) 
  
 (add ((formula A PHI1) (formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 imply PHI2)))) 
  
 (add ((formula A ((not PHI1) or PHI2)))))


(primitiverule (condition ((formula A (not (PHI1 imply PHI2))))) 
  
 (add ((formula A (PHI1 and (not PHI2))))))


(primitiverule (condition ((formula A (PHI1 equiv PHI2)))) 
  
 (add ((formula A ((PHI1 imply PHI2) and (PHI2 imply PHI1))))))


(primitiverule (condition ((formula A (not (PHI1 and PHI2))))) 
  
 (add ((formula A ((not PHI1) or (not PHI2))))))


(primitiverule (condition ((formula A (not (PHI1 equiv PHI2))))) 
  
 (add ((formula A (((not PHI1) and PHI2) or (PHI1 and (not PHI2)))))))


(primitiverule (condition ((formula A (not (PHI1 or PHI2))))) 
  
 (add ((formula A ((not PHI1) and (not PHI2))))))


(primitiverule (condition ((formula A (not (not PHI1))))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (not PHI))(formula A PHI))) 
  
 (add ((formula A bottom))))


(primitiverule (condition ((formula A bottom))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A (diamond DEG PHI)))) 
  
 (add ((formula B PHI) (A link DEG B) (world B))))


(primitiverule (condition ((formula A (not (box DEG PHI))))) 
  
 (add ((formula A (diamond DEG (not PHI))))))


(primitiverule (condition ((formula A (not (diamond DEG PHI))))) 
  
 (add ((formula A (box DEG (not PHI))))))


(primitiverule (condition ((formula A (box DEG PHI))(A link DEG B)(world B))) 
  
 (add ((formula B PHI))))


(primitiverule (condition ((formula A (PHI1 or PHI2)))) 
  
 (add-nondeterminist ((formula A PHI1))((formula A PHI2))))


(primitiverule (condition ((A link DEG B)(A link DEG C)(world A)(world B)(world C))) 
  
 (add ((B link DEG C))))


(primitiverule (condition ((A link DEG B)(B link DEG C)(world A)(world B)(world C))) 
  
 (add ((A link DEG C))))


(primitiverule (condition ((formula A (box DEG PHI)))) 
  
 (add ((formula B PHI) (A link DEG B) (world B))))


(primitiverule (condition ((formula A (OP DEG PHI)))) 
(suchthat (or (equal? OP 'box) (equal? OP 'diamond))) 
 (add ((formula degrees DEG) (world degrees))))


(primitiverule (condition ((formula degrees DEG2)(A link DEG B)(world A)(world B))) 
(suchthat (< DEG2 DEG)) 
 (add ((A link DEG2 B))))


))

