(define rules '((primitiverule (condition ((formula A (not PHI))(formula A PHI))) 
  
 (add ((formula A bottom))))


(primitiverule (condition ((formula A bottom))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((A link x B)(world A)(world B))) 
  
 (add ((A link ancestor B))))


(primitiverule (condition ((A link ancestor B)(B link x C)(world A)(world B)(world C))) 
  
 (add ((A link ancestor C))))


(primitiverule (condition ((formula A (PHI1 and PHI2)))) 
  
 (add ((formula A PHI1) (formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 imply PHI2)))) 
  
 (add ((formula A ((not PHI1) or PHI2)))))


(primitiverule (condition ((formula A (not (PHI1 imply PHI2))))) 
  
 (add ((formula A (PHI1 and (not PHI2))))))


(primitiverule (condition ((formula A (PHI1 equiv PHI2)))) 
  
 (add ((formula A ((PHI1 imply PHI2) and (PHI2 imply PHI1))))))


(primitiverule (condition ((formula A (not (PHI1 and PHI2))))) 
  
 (add ((formula A ((not PHI1) or (not PHI2))))))


(primitiverule (condition ((formula A (not (PHI1 equiv PHI2))))) 
  
 (add ((formula A (((not PHI1) and PHI2) or (PHI1 and (not PHI2)))))))


(primitiverule (condition ((formula A (not (PHI1 or PHI2))))) 
  
 (add ((formula A ((not PHI1) and (not PHI2))))))


(primitiverule (condition ((formula A (not (not PHI1))))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (x PHI))(A link x B)(world B))) 
  
 (add ((formula B PHI))))


(primitiverule (condition ((formula A (f PHI)))) 
  
 (add ((formula A ((x (f PHI)) or PHI)))))


(primitiverule (condition ((formula A (g PHI)))) 
  
 (add ((formula A (PHI and (x (g PHI)))))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI2)))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A ((not PHI1) or PHI2))(formula A (PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or (not PHI2)))(formula A PHI2))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (PHI1 or PHI2)))) 
  
 (add-nondeterminist ((formula A PHI1))((formula A PHI2))))


(primitiverule (condition ((A link ancestor B)(world A)(world B))) 
(suchthat (and (not (equal? A B)) (not (linked? set B 'ancestor A)) (sameformulas? set A B))) 
 (add ((formula B donotrewritediamond) (formula B (tomergewith A)))))


(primitiverule (condition ((formula A (x PHI))(A link x B)(world B))) 
(suchthat (not (node-contains? set A 'donotrewritediamond))) 
 (add ((formula B PHI))))


(primitiverule (condition ((formula A (x PHI)))) 
(suchthat (not (node-contains? set A 'donotrewritediamond))) 
 (add ((formula B PHI) (A link x B) (world B))))


(primitiverule (condition ((formula A (tomergewith B)))) 
 (merge A B) 
 (add ((formula A worldmerged) (world B))))


(primitiverule (condition ((formula A P))) 
(suchthat (proposition? P)) 
 (add ((formula A (P issat)))))


(primitiverule (condition ((formula A (not P)))) 
(suchthat (proposition? P)) 
 (add ((formula A ((not P) issat)))))


(primitiverule (condition ((formula A (PHI issat))(formula A (PSI issat))(formula A (PHI and PSI)))) 
  
 (add ((formula A ((PHI and PSI) issat)))))


(primitiverule (condition ((formula A (PHI issat))(formula A (PHI or PSI)))) 
  
 (add ((formula A ((PHI or PSI) issat)))))


(primitiverule (condition ((formula A (PSI issat))(formula A (PHI or PSI)))) 
  
 (add ((formula A ((PHI or PSI) issat)))))


(primitiverule (condition ((formula A (x PHI))(formula B (PHI issat))(A link x B))) 
  
 (add ((formula A ((x PHI) issat)))))


(primitiverule (condition ((formula A (((x (f PHI)) or PHI) issat)))) 
  
 (add ((formula A ((f PHI) issat)))))


(primitiverule (condition ((formula A (g PHI)))) 
  
 (add ((formula A ((g PHI) issat)))))


(primitiverule (condition ((formula A PHI))) 
 (suchthat (and (not (node-contains? set A (list PHI 'issat))) (not (and (list? PHI) (> (set-card PHI) 1) (or (equal? (car PHI) 'tomergewith) (equal? (cadr PHI) 'issat))))))
 (add ((halt)) ) )


))

