(define rules '((primitiverule (condition ((formula n1 PHI))) 
(suchthat (not (node-contains-pattern? set 'n1 '(length B)))) 
 (add ((formula n1 (length (unquote (sqr (formula-length (quote PHI)))))))))


(primitiverule (condition ((formula A (not PHI))(formula A PHI))) 
  
 (add ((formula A bottom))))


(primitiverule (condition ((formula A bottom))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A (not top)))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A (PHI1 and PHI2)))) 
  
 (add ((formula A PHI1) (formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 imply PHI2)))) 
  
 (add ((formula A ((not PHI1) or PHI2)))))


(primitiverule (condition ((formula A (not (PHI1 imply PHI2))))) 
  
 (add ((formula A (PHI1 and (not PHI2))))))


(primitiverule (condition ((formula A (PHI1 equiv PHI2)))) 
  
 (add ((formula A ((PHI1 imply PHI2) and (PHI2 imply PHI1))))))


(primitiverule (condition ((formula A (not (PHI1 and PHI2))))) 
  
 (add ((formula A ((not PHI1) or (not PHI2))))))


(primitiverule (condition ((formula A (not (PHI1 equiv PHI2))))) 
  
 (add ((formula A (((not PHI1) and PHI2) or (PHI1 and (not PHI2)))))))


(primitiverule (condition ((formula A (not (PHI1 or PHI2))))) 
  
 (add ((formula A (not PHI1)) (formula A (not PHI2)))))


(primitiverule (condition ((formula A (not (not PHI1))))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (box PHI)))) 
  
 (add ((formula A PHI))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI2)))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A ((not PHI1) or PHI2))(formula A (PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (not (diamond PHI))))) 
  
 (add ((formula A (box (not PHI))))))


(primitiverule (condition ((formula A (not (box PHI))))) 
  
 (add ((formula A (diamond (not PHI))))))


(primitiverule (condition ((formula A (PHI1 or (not PHI2)))(formula A PHI2))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (PHI1 or PHI2)))) 
  
 (add-nondeterminist ((formula A PHI1))((formula A PHI2))))


(primitiverule (condition ((formula A (box PHI))(A link  B)(world B))) 
  
 (add ((formula B (box PHI)))))


(primitiverule (condition ((formula A (length L))(A link  B)(world B))) 
  
 (add ((formula B (length (unquote (- L 1)))))))


(primitiverule (condition ((formula A (diamond PHI))(formula A (length L)))) 
(suchthat (> L 0)) 
 (add ((world B) (A link B) (formula B PHI))))


))

